=== debian/changelog ===
ags (3~git) UNRELEASED; urgency=low

  * some release

 -- Tobias Hansen <tobias.han@gmx.de>  Mon, 18 Feb 2013 22:13:14 +0100
